package cn.iocoder.yudao.module.mes.service.organization;

import cn.hutool.core.collection.CollUtil;
import cn.iocoder.yudao.framework.common.util.collection.CollectionUtils;
import cn.iocoder.yudao.module.mes.controller.admin.organization.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.organization.OrganizationDO;

import javax.validation.Valid;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static cn.iocoder.yudao.framework.common.util.collection.CollectionUtils.convertMap;

/**
 * 产线工位 Service 接口
 *
 * @author 内蒙必硕
 */
public interface OrganizationService {

    /**
     * 创建产线工位
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createOrganization(@Valid OrganizationSaveReqVO createReqVO);

    /**
     * 更新产线工位
     *
     * @param updateReqVO 更新信息
     */
    void updateOrganization(@Valid OrganizationSaveReqVO updateReqVO);

    /**
     * 删除产线工位
     *
     * @param id 编号
     */
    void deleteOrganization(Long id);

    /**
     * 获得产线工位
     *
     * @param id 编号
     * @return 产线工位
     */
    OrganizationDO getOrganization(Long id);

    /**
     * 获得产线工位列表
     *带父级组织
     * @param listReqVO 查询条件
     * @return 产线工位列表
     */
    List<OrganizationDO> getOrganizationList(OrganizationListReqVO listReqVO);
    List<OrganizationDO> getOrganizationListByOutIds(Collection<Long> outIds);

    List<OrganizationDO> getOrganizationListNoParent(OrganizationListReqVO listReqVO);
    List<OrganizationRespVO> buildVOList(List<OrganizationDO> list);
    //派工页面渲染今天已经派工的工人
    List<OrganizationRespVO> buildWorkerVOList(List<OrganizationDO> list);
    List<OrganizationDO> getList(Collection<Long> ids);
    default Map<Long, OrganizationDO> getMap(Collection<Long> ids) {
        if (CollUtil.isEmpty(ids)) {
            return new HashMap<>();
        }
        return CollectionUtils.convertMap(getList(ids), OrganizationDO::getId);
    }

    List<OrganizationDO> getOrganizationVOList(Collection<Long> ids);
    default Map<Long, OrganizationDO> getOrganizationVOMap(Collection<Long> ids) {
        if(ids.isEmpty())return new HashMap<>();
        return convertMap(getOrganizationVOList(ids), OrganizationDO::getId);
    }

    List<LineAnalysisTreeDTO.LineNode> deviceParameterAnalysis(String keyword,Integer showDevices);

//    List<DeviceParametersDTO> getDeviceParametersByOrganizationId(Long id);
}